unit Vraag2_U;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ADODB, StdCtrls, Grids, DBGrids, Mask, DBCtrls, ComCtrls, DateUtils,
  dbConnection_U;

type
  TfrmVraag2 = class(TForm)
    pgcVrg2: TPageControl;
    tsVrg21: TTabSheet;
    tsVrg22: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    dbgSpelers: TDBGrid;
    dbgSpeletjies: TDBGrid;
    redVertoon: TRichEdit;
    btnGebiedTeller: TButton;
    btnVeranderTelling: TButton;
    btnVoegby: TButton;
    btnHerstel: TButton;
    Label3: TLabel;
    Label5: TLabel;
    dbgLanFansNavraag: TDBGrid;
    procedure connect;
    procedure FormShow(Sender: TObject);
    procedure btnGebiedTellerClick(Sender: TObject);
    procedure btnVeranderTellingClick(Sender: TObject);
    procedure btnVoegbyClick(Sender: TObject);
    procedure btnHerstelClick(Sender: TObject);
    procedure btnSQLvr211Click(Sender: TObject);
    procedure btnSQLvr212Click(Sender: TObject);
    procedure btnSQLvr213Click(Sender: TObject);
    procedure btnSQLvr214Click(Sender: TObject);
    procedure btnSQLvr215Click(Sender: TObject);

  end;

var
  frmVraag2: TfrmVraag2;

  // Databasis sal automaties koppel
  // Hierdie is die twee tabelle waarmee jy werk
   tblSpelers: TADOtable;
   tblSpeletjies: TADOtable;

  // DB SQL komponent
   qryLanFans: TADOQuery;
   sSQL: String;

implementation

{$R *.dfm}


//==============================================================================
//  VRAAG 2.1 - SQL
//==============================================================================

procedure TfrmVraag2.btnSQLvr211Click(Sender: TObject);

begin
   // Vraag 2.1.1
   sSQL := 'SELECT * FROM tblSpelers ORDER BY Naam';
   qryLanFans.SQL.Clear;
   qryLanFans.SQL.Add(sSQL);
   qryLanFans.Open;
end;

procedure TfrmVraag2.btnSQLvr212Click(Sender: TObject);
begin
   // Vraag 2.1.2
   sSQL := 'SELECT Naam, GebDatum FROM tblSpelers WHERE Month(GebDatum) = 9';
   qryLanFans.SQL.Clear;
   qryLanFans.SQL.Add(sSQL);
   qryLanFans.Open;
end;

procedure TfrmVraag2.btnSQLvr213Click(Sender: TObject);
begin
   // Vraag 2.1.3
   sSQL := 'SELECT SpeelDatum, Round(Avg(Tydsduur),1) AS GemTydsduur ' +
                                 'FROM tblSpeletjies GROUP BY SpeelDatum';
   qryLanFans.SQL.Clear;
   qryLanFans.SQL.Add(sSQL);
   qryLanFans.Open;
end;


procedure TfrmVraag2.btnSQLvr214Click(Sender: TObject);
begin
   // Vraag 2.1.4
   sSQL := 'SELECT Naam, Max(Telling) AS HoogsteTelling ' +
         'FROM tblSpelers P, tblSpeletjies G WHERE P.SpelerID = G.SpelerID '+
                                                      'GROUP BY Naam';
   qryLanFans.SQL.Clear;
   qryLanFans.SQL.Add(sSQL);
   qryLanFans.Open;
end;

procedure TfrmVraag2.btnSQLvr215Click(Sender: TObject);
begin
  sSQL := 'INSERT INTO tblSpeletjies '+
                              'VALUES (76,#24/12/2017#,''HM008'',250,6655)';
   qryLanFans.SQL.Clear;
   qryLanFans.SQL.Add(sSQL);
   qryLanFans.ExecSQL;
   showMessage(IntToStr(qryLanFans.RowsAffected) + ' rekord is bygevoeg.');
end;


//==============================================================================
//  VRAAG 2.2 - DATABASIS KONSTRUKTE
//==============================================================================

procedure TfrmVraag2.btnGebiedTellerClick(Sender: TObject);
var
  sGebied: String;
  iTel: Integer;
begin
  // Kode wat voorsien is
  iTel := 0;
  redVertoon.Clear;
  redVertoon.Paragraph.TabCount := 1;
  redVertoon.Paragraph.Tab[0] := 90;

  // 2.2.1 Spelers e-posgebied tel
  sGebied := Inputbox('Gebied van E-pos','Sleutel die domein van die e-pos waarvoor gesoek moet word in','gmail.com');
  redVertoon.lines.add('SPELER' + #9 + 'E-POSADRES');
  tblSpelers.First;
  while NOT tblSpelers.Eof do
    begin
     if Pos(sGebied,tblSpelers['Epos']) > 0  then
      begin
         redVertoon.lines.add(tblSpelers['Naam'] + #9 + tblSpelers['Epos']);
         Inc(iTel);
      end;
     tblSpelers.Next;
   end;

  redVertoon.lines.add(#13 + 'TOTAAL vir ' + sGebied + ': ' + IntToStr(iTel));
end;


procedure TfrmVraag2.btnVeranderTellingClick(Sender: TObject);
begin
   // 2.2.2 Verander telling
   tblSpeletjies.Edit;
   tblSpeletjies['Telling'] := tblSpeletjies['Telling']  + 250;
   tblSpeletjies.Post;
end;


procedure TfrmVraag2.btnVoegbyClick(Sender: TObject);

begin
  //  2.2.3 Voeg Speletjie by
    tblSpeletjies.Insert;
    tblSpeletjies['SpeelIndx'] :=tblSpeletjies.RecordCount + 1;
    tblSpeletjies['SpeelDatum'] := Date;
    tblSpeletjies['SpelerID'] := tblSpelers['SpelerID'];
    tblSpeletjies['Tydsduur'] := inputBox('Tydsduur van Speletjie','Sleutel tydsduur van speletjie in minute in','');
    tblSpeletjies['Telling'] := inputBox('Telling vir Speletjie','Sleutel die telling in','');
    tblSpeletjies.Post;

end;



{$region Connect}
// Konneksiekode wat voorsien is - MOENIE VERANDER NIE.
// Databasis sal automaties koppel as program uitgevoer word

var
      dbLanFans: TConnection;
      dsrPlayers: TDataSource;
      dsrGames: TDataSource;
      dsrLanFans: TDataSource;

procedure TfrmVraag2.FormShow(Sender: TObject);
begin
  dbLanFans := TConnection.create;
  dbLanFans.dbConnect;
  connect;
  pgcVrg2.ActivePageIndex := 0;
end;

procedure TfrmVraag2.connect;
begin

   tblSpelers := TADOtable.Create(frmVraag2);
   tblSpelers.Connection := dbLanFans.dbConnection;
   tblSpelers.TableName := 'tblSpelers';
   tblSpelers.Open;

   tblSpeletjies := TADOtable.Create(frmVraag2);
   tblSpeletjies.Connection := dbLanFans.dbConnection;
   tblSpeletjies.TableName := 'tblSpeletjies';
   tblSpeletjies.Open;

   dsrPlayers := TdataSource.Create(frmVraag2);
   dsrPlayers.DataSet := tblSpelers;
   dbgSpelers.DataSource := dsrPlayers;

   dsrGames := TdataSource.Create(frmVraag2);
   dsrGames.DataSet := tblSpeletjies;
   dbgSpeletjies.DataSource := dsrGames;

   qryLanFans := TADOQuery.Create(frmVraag2);
   qryLanFans.Connection := dbLanFans.dbConnection;

   dsrLanFans := TdataSource.Create(frmVraag2);
   dsrLanFans.DataSet := qryLanFans;
   dbgLanFansNavraag.DataSource := dsrLanFans;

end;


// Konneksiekode wat voorsien is - MOENIE VERANDER NIE.
procedure TfrmVraag2.btnHerstelClick(Sender: TObject);
var
  bSlaag: boolean;
begin
  dbLanFans.dbConnection.close;
  tblSpelers.Destroy;
  tblSpeletjies.Destroy;

  DeleteFile('LanFans.mdb');
  CopyFile('LanFansBackup.mdb','LanFans.mdb',bSlaag);

  dbLanFans.dbConnect;
  connect;
end;




{$endregion}

end.
