unit player_U;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DateUtils;

type
  TPlayer = class(TObject)

  private
      fEmail: String;
      fName: String;
      fDateOfBirth: String;
      fApproved: Boolean;
      function testEmail(email: String): Boolean;

  public
    constructor create(name, email, dateOfBirth: String);
    function toString: String;
    function testAge(age : integer): String;
    procedure setApproved(approve : boolean);
   // function getApproved: boolean;
    function getEmail: String;
   // function getName: String;
   // function getDateOfBirth: String;
  end;


implementation


{ TPlayer }

// 3.1.1
function TPlayer.getEmail: String;
begin
   result := fEmail;
end;

// 3.1.2

procedure TPlayer.setApproved(approve: boolean);

begin
   fApproved := approve;
end;

// 3.1.3

function TPlayer.testEmail(email: String): Boolean;
var
   iPat : integer;
  bPass: boolean;
begin
   bPass := true;
   if NOT (Uppercase(email)[1] IN ['A'..'Z']) then
      bPass := False;
   result := bPass;
end;


// 3.1.4

constructor TPlayer.create(name, email, dateOfBirth: String);
begin
   fName := name;
   if testEmail(email) then
     fEmail := email
    else fEmail := 'ERROR';
   fDateOfBirth := dateOfBirth;
   fApproved := false;
end;


// 3.1.5

function TPlayer.testAge(age: integer): String;
var
   iRealAge : Integer;

begin
    iRealAge := YearsBetween(date,StrToDate(fDateOfBirth));

    if iRealAge >= age then
      result := 'APPROVED'
     else result := 'REJECTED';
end;


// Provided Code - do not change

function TPlayer.toString: String;
var
 sOut, sApp: String;
begin
  sOut := 'Name: ' + fName + #13;
  sOut := sOut + 'E-mail: ' + fEmail + #13;
  sOut := sOut + 'Date of Birth: ' + fDateOfBirth + #13;
  if fApproved then
     sApp := 'YES'
    else sApp := 'NO';
  sOut := sOut + 'Approved: ' + sApp + #13;
  result := sOut;
end;




end.
